# In silico analysis of Design of Experiment methods for metabolic pathway optimization


## Description
Repository for the project regarding the analysis of the performance of DoE designs to find optimal production strains and effect of enzyme concentration on production using data generated with a kinetic model of the curcumin pathway.

## General overview

- `KineticModel`

    In silico data for the analysis of DoE designs was generated using a kinetic data of the curcumin pathway available at: https://gitlab.com/wurssb/Modelling/kinetics_curcumin_pathway. In this directory you can find:

    - `kinetic_model_parameters.csv`: kinetic model parameters used for simulation of the pathway model, see https://gitlab.com/wurssb/Modelling/kinetics_curcumin_pathway for details on the simulations.
    - `fullfactorial_production_triplicates_noise.csv`: results of the simulation of the full factorial library of strains with the kinetic model, triplicates of each strain in the design were generated adding 5% or 20% of Gaussian noise.

- `GenerationOfDesigns`

    In this directory you can find the R scripts used to select strains based on DoE designs, DoE designs with failed strains, (`doe_designs_permutations.R`) or random sampling (`random_sampling.R`), train linear models with production data from the selected strains and perform ANOVA on the model coefficients. Files generated with these scripts are also provided.

- `AnalysisOfDesigns`

    In this directory you can find:
    - `analysis_fullfactorial.Rmd`: R script to analyze the full factorial data generated with the kinetic model.
    - `analysis_designs.ipynb`: python script to analyze the ability of DoE designs and random sampling to correctly estimate linear model coefficients, and their significance, as well as the ability of the models to find the strains with highest curcumin production in the design space.

- `MachineLearning`

    In this directory you can find the `random_forest.ipynb` script to analyze the performance of random forest models trained with data from DoE designs or random sampling. Files generated by this script are also provided (`cv_r2_20noise.csv`, `cv_r2_positive_20noise.csv`, `random_forest_dict_20noise.pkl`, `random_forest_dict_20noise_noCV.pkl`).

- `Figures`

    Directory with figures generated bu the scripts.

## Dependencies

- python (3.7+)
    - os
    - pandas
    - numpy
    - pickle
    - matplotlib
    - sklearn
- R (4.3.1.)
    - FrF2
    - plyr
    - combinat

## Authors

* Sara Moreno Paz

## License:
This project is licensed under the MIT License - see the LICENSE file for details.
